using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System.Threading.Tasks;

namespace Mvc
{
public class Program
{
    public static void Main()
    {
        Host.CreateDefaultBuilder()
            .ConfigureWebHostDefaults(builder => builder
            .ConfigureServices(services => services
                    .AddRouting()
                    .AddMvcControllers())
            .Configure(app => app
            .UseDeveloperExceptionPage()
                .UseRouting()
                .UseEndpoints(endpoints => endpoints.MapMvcControllerRoute("default","{controller}/{action}"))))
            .Build()
            .Run();
    }

}

public class FoobarController : Controller
{
    [HttpGet("/{foo}")]
    public Task FooAsync()
    {
        return ActionContext.HttpContext.Response.WriteAsync(nameof(FooAsync));
    }

    public Task BarAsync()
    {
        return ActionContext.HttpContext.Response.WriteAsync(nameof(BarAsync));
    }
}
}
